//Developer:	Qishi Wu
//Date:		June 2004
//Place:		CSMD @ ORNL

#include <sys/socket.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include <strings.h>
#include <errno.h>

#include "udpcli.h"
#include "ioutil.h"
#include <pthread.h>
//#include <queue>

#define DEBUGMODE

//queue<char *> *dgQueue;
pthread_mutex_t mutex; 
double rtt;
struct timeval beginSend, timeCur;
		
int main(int argc, char **argv)
{
	char	     pSvrAddr[16] = {SERVER_IP};
     pthread_mutex_init(&mutex, NULL);
     //dgQueue = new queue<char *>;
	int		svrPort = SERVER_PORT;	
	int		mtu	= MTU;
	int		dgSize = DGSIZE;        //bytes
	int		dataSize = DATASIZE;    //bytes
	int		cwin = 0;			    //datagrams
	int		sleep_us = 0;		    //microseconds
	double	reqBW = 0.0;
	INT64	fileSize_bytes = 0;	    //bytes
	int 	     totalDgsInFile;
	char	     pRequestName[100];
	char	     pSendLine[MAXLINELEN], pTempLine[MAXLINELEN];
	//double	rtt;                    //ms
     pthread_t threadSendDgs;
     bool bComplete = false;
     
	int		sockfd_udp, sockfd_tcp;
	struct sockaddr_in servaddr;
	socklen_t servlen = sizeof(servaddr);
     bool      bAllSent = false;
     bool      readOnce = false;

     ///////////////////////
     char *pRecvLine = new char[MAXLINELEN];
     int numRexmt = 0;
     int indexRexmt = 0;
     int seqNoRexmt = 0;
     char *pDatagram;
     int numRead = 0;
     int numSent = 0;
     int rexmtCount = 0;
     /////////////////////

	if(argc == 2)
	{
		if(strncmp(argv[1], "--help", 6) == 0)
		{
			PrintCommand();
			return(0);		
		}
		else
		{
			printf("\n\ncommand format error. Use udpcli --help.\n\n");
			return(0);
		}
	}

	pRequestName[0] = '\0';
	ParameterParser(argc, argv, pSvrAddr, &svrPort,
			&mtu, &cwin, &sleep_us, &reqBW,
			pRequestName);

     double setRate = 0.0;
	
	dgSize = mtu - 28;
     //pDatagram[j][i] = (char)((( (i-4)*(rand()*100) ) %26) +65);
     pDatagram = new char[dgSize];
     for(int i = 4; i < dgSize; i++)
          pDatagram[i] = (char)((( (i-4) * 1  )%26)+65); 
     
	dataSize = dgSize - HEADER;
	if(reqBW != 0.0)
	{
		cwin = 1; //datagrams

          sleep_us = getSleepFromRate(dgSize, reqBW);
          if(sleep_us > 0)
               setRate = getRateFromSleep(dgSize, sleep_us);
          else
               setRate = reqBW;
         
          printf("\nRequested %1.0f Mbps, rate set to %1.0f Mbps\n", reqBW, setRate);
               
	}
	else if(cwin != 0 && sleep_us != 0)
	{
         setRate = getRateFromSleep(dgSize, sleep_us); 
	    printf("\nRate set to %1.0f Mbps\n", setRate);
	}
	else
	{
		printf("\nBoth requested sending rate and cwin&sleep_us are not specified. Use default ones.\n");
		reqBW = SENDRATE;
		cwin = 1; //datagrams

          sleep_us = getSleepFromRate(dgSize, reqBW);
          setRate = getRateFromSleep(dgSize, sleep_us);
          printf("\nRequested %1.0f Mbps, rate set to %1.0f Mbps\n", reqBW, setRate);
	}

	FileInfoNode *pHead = new FileInfoNode;
	//CreateFileList(&pHead, pRequestName);

     //temp code**
     strncpy(pHead->pFileName, pRequestName, strlen(pRequestName));
	pHead->bIsADir = false;
	pHead->pNext = NULL;     
     //end temp code**


	FileInfoNode *pTempNode = pHead, *pTempNodeNext = NULL;
	int count = 1;

	printf("\n-----------Transfer info----------");
	printf("\nDestination Svr Addr: %s", pSvrAddr);
	printf("\nDestination Svr Port: %d", svrPort);
	printf("\nMTU size: %d bytes", mtu);
	printf("\nRequested sending rate: %8.2lf Mbps", reqBW);
	printf("\nFixed cwin: %d datagrams", cwin);
	printf("\nFixed sleep_us: %d us", sleep_us);
	printf("\n\n*********File List to be Transferred*********");
	fflush(stdout);
   

	while(pTempNode != NULL)
	{
          
		printf("\n\n%d. Transfer ", count++);
		if(pTempNode->bIsADir)
		{
			printf("DIR: %s", pTempNode->pFileName);
			printf("\n--------------------------------------------------------");
		}
		else 
		{
			//ReadFileSizeInBytes(pTempNode->pFileName, fileSize_bytes);
               sscanf(pRequestName,"%d",&fileSize_bytes);
               fileSize_bytes *= 1000000;
			totalDgsInFile = (int)ceil((double)fileSize_bytes / (double)dataSize);
			printf("FILE: %s (%lld bytes)", pTempNode->pFileName, fileSize_bytes);
		}
          
		sockfd_udp = socket(AF_INET, SOCK_DGRAM, 0);
		sockfd_tcp = socket(AF_INET, SOCK_STREAM, 0);
		//setsockopt(sockfd_udp, SOL_SOCKET, SO_BROADCAST, &on, sizeof(on));
		bzero(&servaddr, sizeof(servaddr));
		servaddr.sin_family = AF_INET;
		inet_pton(AF_INET, pSvrAddr, &servaddr.sin_addr);
		servaddr.sin_port = htons((unsigned short)svrPort);
		if(connect(sockfd_tcp, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0)
		{
			printf("\nCan't connect to the TCP server %s listening at port# %d\n\n", pSvrAddr, svrPort);
			exit(5);
		}	

		//////////////////////////////////////////////////////////
		///////////////read and send file/////////////////////////
		if(pTempNode->bIsADir)
		{
			sprintf(pSendLine, "DIR %s\n", pTempNode->pFileName);
			writen(sockfd_tcp, pSendLine, strlen(pSendLine));
		}
		else
		{
			sprintf(pSendLine, "FILE MTU %d\n", mtu);
			writen(sockfd_tcp, pSendLine, strlen(pSendLine));
			//printf("\n\nWait for threeway handshake with the server ...");
			sleep(1); //why wait one second?
			int targetRate = ThreeWayHandshakeAtSender(sockfd_udp, servaddr, servlen, cwin, &sleep_us, pTempNode->pFileName, fileSize_bytes, dgSize, totalDgsInFile, rtt);
               printf("sleep: %d\n", sleep_us);
               printf("Negotiated rate fom server: %d\n", targetRate);
			ReadLine(sockfd_tcp, pTempLine, 9);
			if(strncmp(pTempLine, "SVRREADY", 8) == 0)
			{
				//the following does udp measurement
                    UDPParams *p = new UDPParams;
                    p->sockfd_tcp = sockfd_tcp;
                    p->sockfd_udp = sockfd_udp;
                    p->servaddr = servaddr;
                    p->servlen = servlen;
                    p->cwin = cwin;
                    p->sleep_us = &sleep_us;
                    p->pFileName = pTempNode->pFileName;
                    p->fileSize_bytes = fileSize_bytes;
                    p->dgSize = dgSize;
                    p->totalDgsInFile = totalDgsInFile;
                    p->bComplete = &bComplete;
                    p->rexmtCount = &rexmtCount;
                    p->bAllSent = &bAllSent;
                    if(pthread_create(&threadSendDgs, NULL, SendUDPDatagrams, p) != 0)
               	{
               		printf("\nError: cannot thread!\n\n");
               		fflush(stdout);
               		exit(0);
               	}
				//SendUDPDatagrams(sockfd_tcp, sockfd_udp, servaddr, servlen, cwin, sleep_us, pTempNode->pFileName, fileSize_bytes, dgSize, totalDgsInFile, &bComplete);
			
                    while(true)
                    {

               		readn(sockfd_tcp, pRecvLine, 4);

                         
               		if(memcmp(pRecvLine, "RXM", 3) == 0)
               		{
               			readn(sockfd_tcp, &numRexmt, 4);
               			numRexmt = ntohl(numRexmt);
                              rexmtCount += numRexmt;
               			readn(sockfd_tcp, pRecvLine, 4 * numRexmt);
                              
                              if(/*numRexmt*sleep_us > 50000*/ true) //parametrize this later
                              {

                                   //spawn off thread, so rate control
                                   //can function, uninterrupted
                                   char *pRecvLineCopy = new char[MAXLINELEN];
                                   memcpy(pRecvLineCopy,pRecvLine,4 * numRexmt);
                                   pthread_t thrRexmt;
                                   RexmtParams *p = new RexmtParams;
                                   p->sockfd_udp = sockfd_udp;
                                   p->servaddr = servaddr;
                                   p->sleep_us = sleep_us;
                                   p->dgSize = dgSize;
                                   p->servlen = servlen;
                                   p->pRecvLine = pRecvLineCopy;
                                   p->numRexmt = numRexmt;
                                   if(pthread_create(&thrRexmt, NULL, Rexmt, p) != 0)
               	               {
               		             printf("\nError: cannot thread!\n\n");
               		             fflush(stdout);
               		             exit(0);
               	               }

                              }
                              else
                              {
                                   pthread_mutex_lock(&mutex);
                                   gettimeofday(&timeCur, NULL);
                    			for(indexRexmt = 0; indexRexmt < numRexmt; indexRexmt ++)
                    			{
                    				memcpy(&seqNoRexmt, pRecvLine + indexRexmt * 4, 4);
                    				memcpy(pDatagram, &seqNoRexmt, 4);

                                        //fread("read (dgSize - 4) bytes from file stream")
                                        numRead = dgSize - 4;
                                        
                    				if( (numSent = sendto(sockfd_udp, pDatagram, numRead + 4, 0, (struct sockaddr *)&servaddr, servlen)) != numRead + 4)
                    				{
                    					printf("\nsendto error");
                                             fflush(stdout);
                    					exit(0);
                    				}

                                        while(true)
                                        {
                                             gettimeofday(&beginSend, NULL);
                                             if((beginSend.tv_usec-timeCur.tv_usec) + (beginSend.tv_sec-timeCur.tv_sec)* 1000000 > sleep_us)
                                             {
                                                  gettimeofday(&timeCur, NULL);
                                                  break;
                                             }
                                        }
                                        
     			               }//for
                                   pthread_mutex_unlock(&mutex);
                              }
                         }//if
                         else if(memcmp(pRecvLine, "ACK", 3) == 0)
                         {
                              bComplete = true;
                              printf("Transfer complete! Waiting for stats...\n");
                              usleep(10000);
                         	//ReadLine(sockfd_tcp, pRecvLine, MAXLINELEN);
                              readn(sockfd_tcp, pRecvLine, MAXLINELEN); 
                         	ReceiveAcknowledge(pRecvLine, sockfd_tcp);
                         	break;
                         }
                         else if(memcmp(pRecvLine, "RATE", 4) == 0)
                         {
                              
                              int newRate = 0;
                              readn(sockfd_tcp, pRecvLine, 5);
                              sscanf(pRecvLine, " %d", &newRate);
                              //readn(sockfd_tcp, &newRate, 4);
                              printf("\nRate change request: %d\n", newRate);
                              sleep_us = getSleepFromRate(dgSize, newRate);
                              printf("New sleep: %d\n",sleep_us);
                              
                              fflush(stdout);
                              //sleep_us += 1;
                         }
                         if(!bAllSent)
                              usleep(10000); //10 ms
                    }//while(true) - sending
                    pthread_join(threadSendDgs, NULL);
		          close(sockfd_tcp);
		          close(sockfd_udp);
               }//if svrready
		}//else not a dir
		///////////////read and send file/////////////////////////
		//////////////////////////////////////////////////////////


		pTempNodeNext = pTempNode->pNext;
		pTempNode = pTempNodeNext;
	} //end of while loop through file list

	printf("\n\n*********All file transfer completed!*********\n\n\n");	
	DeleteFileList(pHead);
	return 0;
}

void *Rexmt(void *arg)
{
     printf("new Rexmt thread\n");
     RexmtParams *p = (RexmtParams *)arg;
     int       sockfd_udp =   (int)p->sockfd_udp;
     struct    sockaddr_in servaddr = (struct sockaddr_in)p->servaddr;
     socklen_t servlen =      (socklen_t)p->servlen;
     int       sleep_us =     (int)p->sleep_us;
     int       dgSize =       (int)p->dgSize;
     int       numRexmt =     (int)p->numRexmt;
     char      *pRecvLine =   (char *)p->pRecvLine;

     printf("dgSize:%d numRexmt:%d sleep_us%d\n", dgSize, numRexmt, sleep_us);
     printf("%d%d%d%d%d\n",pRecvLine[0],pRecvLine[1],pRecvLine[2],pRecvLine[3],pRecvLine[4]);

     int seqNoRexmt = 0;
     int indexRexmt = 0;
     int numRead = 0;
     int numSent = 0;
     char *pDatagram = new char[dgSize];
     for(int i = 4; i < dgSize; i++)
          pDatagram[i] = (char)((( (i-4) * 1  )%26)+65); 

     pthread_mutex_lock(&mutex);
     if( (numSent = sendto(sockfd_udp, pDatagram, dgSize, 0, (struct sockaddr *)&servaddr, servlen)) != dgSize)
	{
		printf("\n!!!sendto error %d %d %d\n", numSent, sockfd_udp, numRead);
          exit(0);
	}

     
     gettimeofday(&timeCur, NULL);
     for(indexRexmt = 0; indexRexmt < numRexmt; indexRexmt ++)
	{
		memcpy(&seqNoRexmt, pRecvLine + indexRexmt * 4, 4);
		memcpy(pDatagram, &seqNoRexmt, 4);

          //fread("read (dgSize - 4) bytes from file stream")
          numRead = dgSize - 4;
          
		if( (numSent = sendto(sockfd_udp, pDatagram, numRead + 4, 0, (struct sockaddr *)&servaddr, servlen)) != numRead + 4)
		{
			printf("\nsendto error %d %d %d\n", numSent, sockfd_udp, numRead);
               exit(0);
		}

          while(true)
          {
               gettimeofday(&beginSend, NULL);
               if((beginSend.tv_usec-timeCur.tv_usec) + (beginSend.tv_sec-timeCur.tv_sec)* 1000000 > sleep_us)
               {
                    gettimeofday(&timeCur, NULL);
                    break;
               }
          }
          
     }//for
     pthread_mutex_unlock(&mutex);
}

void *SendUDPDatagrams(void *arg)
{
	UDPParams *p =           (UDPParams *)arg;
     int       sockfd_tcp =   (int)p->sockfd_tcp;
     int       sockfd_udp =   (int)p->sockfd_udp;
     struct    sockaddr_in servaddr = (struct sockaddr_in)p->servaddr;
     socklen_t servlen =      (socklen_t)p->servlen;
     int       cwin =         (int)p->cwin;
     int       *sleep_us =     (int *)p->sleep_us;
     char      *pFileName =   (char *)p->pFileName;
     INT64     fileSize_bytes = (INT64)p->fileSize_bytes;
     int       dgSize =       (int)p->dgSize;
     int       totalDgsInFile = (int)p->totalDgsInFile;
     bool      *bComplete =   (bool *)p->bComplete;
     int       *rexmtCount =  (int *)p->rexmtCount;
     bool		*bAllSent =   (bool *)p->bAllSent;
     
     *bAllSent = false;

     FILE 		*fpData;
	char 		*pDatagram;
	int			dgSentCount = 0, dgSentCountCWIN = 0, dgSentCountOnePeriod = 0, curDgSeqNo;
	INT64		totalBytesSoFar = 0;
	int		     forcedRxmtLastDgCount = 0;
	int			numRead = 0, numSent = 0;
	struct timeval	timeCur, timeThroughput, beginSend;
	long int	     startTime, curTime, endTime, timeInterval;	

	char		     pRecvLine[MAXLINELEN];
	int			numRexmt, indexRexmt, seqNoRexmt, lastDgSeqNo = totalDgsInFile - 1;

	
	INT64		goodBytesSentSoFar = 0;
	double		duration; //in seconds

     //last two not used
	double		sendingRate, rxmtrate, averxmtrate, smthrxmtrate;	
	double		percentDone = 0.0, prePercentDone = 0.0;

     //not used
	int			rxmtEventCount = 0, adjustSleep_us;
     double         totalSend = 0.0;
					
	pDatagram = new char[dgSize];
          
     for(int i = 4; i < dgSize; i++)
     {
          //pDatagram[j][i] = (char)((( (i-4)*(rand()*100) ) %26) +65);
          pDatagram[i] = (char)((( (i-4) ) %26) +65);
     }

     /*for(int i = 4; i < 10; i++)
         printf("%c",pDatagram[i]);
     fflush(stdout);*/
 
	dgSentCount = 0;
	dgSentCountCWIN = 0;
	curDgSeqNo = 0;
	totalBytesSoFar = 0;

	/*if(!(fpData = fopen64(pFileName, "r")))
	{
		printf("\nopen %s error!", pFileName);
		goto EXIT;
	}*/
	
	printf("\nStart sending ... ");
	fflush(stdout);
	sleep(1); //why ?
     //usleep(100);
	gettimeofday(&timeCur, NULL);
	startTime = timeCur.tv_usec + timeCur.tv_sec * 1000000;	

	while(true)
	{
          if(*bComplete)
          {
               gettimeofday(&timeCur, NULL);
               *bComplete = false;
               break;
          }

     	if(*bAllSent)
     	{
               usleep(5000); //5 ms -- this is to slow down resending of last dg
     		forcedRxmtLastDgCount ++;
     		//tempFilePos = (INT64)curDgSeqNo * (dgSize - 4);
     		//fseek(fpData, tempFilePos, SEEK_SET);
     	}

     	curDgSeqNo = htonl(curDgSeqNo);
     	memcpy(pDatagram, &curDgSeqNo, 4);
     	curDgSeqNo = ntohl(curDgSeqNo);

          //comment this out to the else to read from memory
          /*if(!bAllSent)
               numRead = fread(pDatagram + 4, 1, dgSize - 4, fpData);
          else*/
               numRead = dgSize - 4;

 
          //gettimeofday(&beginSend, NULL);
          pthread_mutex_lock(&mutex);
     	if( (numSent = sendto(sockfd_udp, pDatagram, numRead + 4, 0, (struct sockaddr *)&servaddr, servlen)) != numRead + 4)
     	{
     		printf("\nnumSent: %d, sendto error when sending dgSeqNo: %d\n\n", numSent, curDgSeqNo);
     		goto EXIT;
     	}
          pthread_mutex_unlock(&mutex);
          //gettimeofday(&timeCur, NULL);
          //totalSend += (timeCur.tv_usec-beginSend.tv_usec) + (timeCur.tv_sec-beginSend.tv_sec) * 1000000;
          
          curDgSeqNo ++;
     	dgSentCount ++;
     	//dgSentCountCWIN ++;
          //dgSentCountOnePeriod ++;
          totalBytesSoFar += (INT64)(numSent + 28);
     	if(!*bAllSent)
     		goodBytesSentSoFar += (INT64)(numRead);

     	if(curDgSeqNo > lastDgSeqNo)
     	{
               gettimeofday(&timeThroughput, NULL);
     		*bAllSent = true;
     		curDgSeqNo = lastDgSeqNo;
     	}


     	percentDone = (double)curDgSeqNo / (double)lastDgSeqNo * 100.0;
     	if(percentDone - prePercentDone > 10.0)
     	{
     		printf("%d%% ", (int)percentDone);
     		fflush(stdout);
     		prePercentDone = percentDone;
     	}

          while(true)
          {
               gettimeofday(&beginSend, NULL);
               if((beginSend.tv_usec-timeCur.tv_usec) + (beginSend.tv_sec-timeCur.tv_sec)* 1000000 > *sleep_us)
               {
                    gettimeofday(&timeCur, NULL);
                    break;
               }
          }
		
	}  // end of while(1)
	
	printf("\nRTT: %lf\n", rtt);
	endTime = timeCur.tv_usec + timeCur.tv_sec * 1000000;
     long int endTimeThrough = timeThroughput.tv_usec + timeThroughput.tv_sec * 1000000;
	duration = (double) (endTime - startTime - (rtt*1000)) / 1000000;
     double durThrough = (double) (endTimeThrough - startTime) / 1000000;
	sendingRate = (double)totalBytesSoFar * 8 / durThrough / 1000000;  // rate: Mbps
     fflush(stdout);
	printf("\nSender statistics:");
	printf("\nTotal sent datagrams: %d, Total sent bytes: %lld", dgSentCount, totalBytesSoFar);		
	printf("\nSent good dgs: %d, Sent good bytes: %lld", curDgSeqNo + 1, goodBytesSentSoFar);
	printf("\nRequested rxmt: %d dgs, forced retransmission of last dg: %d times", *rexmtCount, forcedRxmtLastDgCount);
	printf("\ntotalSentDgs %d = %d(goodDgs) + %d(requested rxmt) + %d(forced rxmt of last dg)", dgSentCount, curDgSeqNo+1, *rexmtCount, forcedRxmtLastDgCount);
	printf("\nsend rate (throughput): %8.2lf Mbps, rxmt rate: %lf%%", sendingRate, 100.0 * (double)(*rexmtCount) / dgSentCount);
     printf("\ntotal time: %2.8lf s", duration);
     printf("\nGoodput: %8.2lf Mbps", (double)goodBytesSentSoFar * 8 / duration / 1000000);
	printf("\n--------------------------------------------------------");

     if(BETA == 0.00)
     {
          double dataBits = (dgSize + HEADER)*8.0;
          double slp = 1.0* *sleep_us;
          double baseRate = dgSize*8.0/ slp;
          double b = -1.0*(sendingRate - baseRate)*(slp * slp/dataBits);
          printf("\nBeta calculation is: %f \n", b);
     }

     fflush(stdout);	

EXIT:
	shutdown(sockfd_tcp, 1);
     //fclose(fpdata);
	
	//delete [] *pDatagram;
}


void ReadFileSizeInBytes(char *pFileName, INT64 &fileSize_bytes)
{
	struct stat fstatus;

	int ret = stat(pFileName, &fstatus);
	
	if(ret == -1 && errno == ENOENT)
	{
		printf("\nThe specified file %s doesn't exist and file size is not specified.\n\n", pFileName);
		exit(0);
	}
	else if(ret != -1)
	{
		//printf("\nFile %s exists and will be sent.\n", pFileName);
		INT64 temp64 = (INT64)(fstatus.st_size);
		fileSize_bytes = temp64;
	}
	else
	{
		printf("\nSomething wrong with the file %s.\n", pFileName);
		exit(0);
	}
}


void PrintCommand()
{
	printf("\nCommand format:");
	printf("\n\nudpcli -s svrIP -p svrPort -m MTU_bytes -w cwin_dg -i idleTime_us -r requestRate_Mbps -f \"fileName\"\n\n");
	printf("\nsvrIP (%s):\tserver IP addr", SERVER_IP);
	printf("\nsvrPort (%d):\t\tserver port #", SERVER_PORT);
	printf("\nMTU_bytes (%d):\tMTU size in bytes", MTU);
	printf("\ncwin_dg (%d):\t\twindow size in datagrams", CWIN);
	printf("\nidleTime_us (%d):\tidle or sleep time in us", SLEEP);
	printf("\nrequestRate_Mbps(%4.0lf):\trequested sending rate in Mbps", SENDRATE);
	printf("\n\"fileName\":\t\tfile or dir name to be sent.\n\n");
	printf("\nNote:\n1. Option -r requestRate_Mbps overwrites the values of cwin_dg & idleTime_us.");
	printf("\n2. Use double quotation marks for file name if wild card is used. e.g. \"send*.dat\"\n\n");
}

void ParameterParser(int argc, char **argv, char *pSvrAddr, int *pSvrPort,
					 int *pMTU, int *pcwin, int *psleep_us, double *pReqBW,
					 char *pRequestName)
{
	bool bFileNameSet = false;

	for(int i = 1; i < argc; i ++)
	{
		if(strncmp(argv[i], "-s", 2) == 0)
			strcpy(pSvrAddr, argv[++i]);
		else if(strncmp(argv[i], "-p", 2) == 0)
			*pSvrPort = atoi(argv[++i]);
	 	else if(strncmp(argv[i], "-m", 2) == 0)
	 		*pMTU = atoi(argv[++i]);
	 	else if(strncmp(argv[i], "-w", 2) == 0)
	 		*pcwin = atoi(argv[++i]);
		else if(strncmp(argv[i], "-i", 2) == 0)
	 		*psleep_us = atoi(argv[++i]);
	 	else if(strncmp(argv[i], "-r", 2) == 0)
	 		*pReqBW = atof(argv[++i]);
	 	else if(strncmp(argv[i], "-f", 2) == 0)
		{
			bFileNameSet = true;
	 		strcpy(pRequestName, argv[++i]);
		}
	 	else
	 	{
	 		printf("\nCommand format error. argv[%d]: %s\n\n", i, argv[i]);
			PrintCommand();
	 		exit(0);
	 	}
	}
	if(!bFileNameSet)
	{
		printf("\nError: file name needs to be specified.\n\n");
		PrintCommand();
		exit(0);
	}
	if(*pSvrPort <= 0 || *pMTU <= 0)
	{
		printf("\nCommand format error: check svr port # and MTU size.\n\n");
		PrintCommand();
	 	exit(0);
	}
}


int ThreeWayHandshakeAtSender(int sockfd_udp, struct sockaddr_in servaddr, socklen_t servlen, int cwin, int *sleep_us, char *pFileName, INT64 fileSize, int dgSize, int totalNumOfDgs, double &rtt2)
{
    bool				bSYNAcked = false;
    struct timeval 		tv;
	fd_set 				readfdset;
	char				*pDg = new char[dgSize];
	struct timeval		curTime;
	long int			sentTime, recvTime;
	int rate = getRateFromSleep(dgSize,*sleep_us);
     if(rate == -1)
          rate = 1000*1000; //1000 Gbps should be enough
     
	
	//printf("\n********************************");
	//printf("\nUDP Threeway Handshake @ Sender:");
	while(!bSYNAcked)
	{
		sprintf(pDg, "SYN:%d %d %s %lld %d\n", cwin, rate, pFileName, fileSize, totalNumOfDgs);
		sendto(sockfd_udp, pDg, 200, 0, (struct sockaddr *)&servaddr, servlen);
		gettimeofday(&curTime, NULL);
		sentTime = curTime.tv_sec*ONEMILLION + curTime.tv_usec; //usec
		//printf("\n===>Sent SYN to server ...");		
		tv.tv_sec = 2;
		tv.tv_usec = 0;
		FD_ZERO(&readfdset);
		FD_SET(sockfd_udp, &readfdset);
	
		if(select(sockfd_udp+1, &readfdset, NULL, NULL, &tv) > 0)	
		{
			bzero(pDg, sizeof(pDg));

			MyRecvFrom(sockfd_udp, pDg, 200, 0, (struct sockaddr *)&servaddr, &servlen);	
			gettimeofday(&curTime, NULL);
			recvTime = curTime.tv_sec*ONEMILLION + curTime.tv_usec; //usec
			rtt = (double)(recvTime - sentTime) / 1000.0; //ms
               
			if(strncmp(pDg, "ACKSYN", 6) == 0)
			{
				//printf("\n<===Received ACKSYN from server (RTT: %lf ms).", rtt);			
				sscanf(pDg, "ACKSYN %d\n", &rate);

				*sleep_us = getSleepFromRate(dgSize,rate);
                    
				bSYNAcked = true;
				sprintf(pDg, "ACK %lf\n", rtt);
				sendto(sockfd_udp, pDg, 20, 0, (struct sockaddr *)&servaddr, servlen);
				//printf("\n===>Sent ACK to server ...");
				//printf("\nThreeway Handshake: ESTABLISHED.");	
				//printf("\n*******************************\n\n");
				//fflush(stdout);
			}
		}
	}
	delete [] pDg;
     return rate;
}



void ReceiveAcknowledge(char *pLine, int sockfd_tcp)
{
	INT64 	numRecvBytes;
	int		numRecvDatagrams;
	double	recvRate, rxmtRate;
	int		sleep_us, cwin;
     int i = 0;

	sscanf(pLine, "%d %d %lld %d %lf %lf", &sleep_us, &cwin, &numRecvBytes, &numRecvDatagrams, &recvRate, &rxmtRate);
     fflush(stdout);
	printf("\nReceiver statistics:");
	printf("\n--------------------------------------------------------------------\n");
	printf("Total recv bytes: %lld, total recv datagrams: %d\nrecv rate: %8.2lf Mbps, rxmt rate: %lf%% \n", numRecvBytes, numRecvDatagrams, recvRate, rxmtRate);
	printf("--------------------------------------------------------------------\n");
	fflush(stdout);
}

bool IsFileListReady(char *pFileListName)
{
	struct stat fileListStatus;
	int ret = stat(pFileListName, &fileListStatus);

	if(ret == -1 && errno == ENOENT)
	{
		printf("\nError: file list %s is not ready.\n\n", pFileListName);
		return false;
	}
	else if(ret != -1)
	{
		int tempSize = fileListStatus.st_size;
		if(tempSize <= 0)
			return false;
		else
			return true;
	}
	return false;
}

void CreateFileList(FileInfoNode **ppHead, char *pRequestName)
{
	FileInfoNode *pTempNode, **ppTempNext = ppHead;
	char pDir[100], pTempLine[MAXLINELEN];
	FILE	*fpFileList;
	bool	bAppendDir = false;
	struct stat filestat;
	int		type;
	
	bzero(pDir, 100);

	sprintf(pTempLine, "ls -R -1 %s > .tempfilelist", pRequestName);
	if(system(pTempLine) == -1)
	{
		printf("\nError: call system() error.\n\n");
		exit(0);
	}
	if(!IsFileListReady(".tempfilelist"))
	{
		//printf("\nError: No file is selected for transfer.\n\n");
		exit(0);
	}
	fpFileList = fopen(".tempfilelist", "r");
	while(!feof(fpFileList))
	{
		pTempLine[0] = '\0';
		fgets(pTempLine, MAXLINELEN, fpFileList);
		if(pTempLine[0] == '\n' || pTempLine[0] == '\0')
			continue;
		pTempNode = new FileInfoNode;
		bzero(pTempNode->pFileName, strlen(pTempNode->pFileName));
		pTempNode->pNext = NULL;
		(*ppTempNext) = pTempNode;
		ppTempNext = &(pTempNode->pNext);
		if(pTempLine[strlen(pTempLine)-2] == ':')
		{
			pTempNode->bIsADir = true;
			bzero(pDir, 100);
			strncpy(pDir, pTempLine, strlen(pTempLine)-1);
			pDir[strlen(pTempLine)-2] = '\0';
			strncpy(pTempNode->pFileName, pDir, strlen(pTempLine)-2);
			bAppendDir = true;
		}
		else
		{
			if(bAppendDir)	
			{
				strncat(pTempNode->pFileName, pDir, strlen(pDir));
				strncat(pTempNode->pFileName, "/", 1);
			}
			strncat(pTempNode->pFileName, pTempLine, strlen(pTempLine)-1);

			if(stat(pTempNode->pFileName, &filestat) == -1)
			{
				printf("\nError: file or dir %s does not exist.\n\n", pTempNode->pFileName);
				exit(0);
			}
			type = filestat.st_mode & S_IFMT;
			switch(type)
			{
				case S_IFDIR : //is a dir
						delete pTempNode;
						break;
				//case S_IFLNK :
				//		"symbolic link";
				//		break;
				case S_IFREG : //is a regular file
						pTempNode->bIsADir = false;
						break;
				default	:
						printf("\nFile %s error\n\n", pTempNode->pFileName);
						exit(0);
			}
		}
	}
	fclose(fpFileList);
	if(system("rm .tempfilelist") == -1)
	{
		printf("\nError: can not remove the temp file.\n\n");
		exit(0);
	}
}

void DeleteFileList(FileInfoNode *pHead)
{
	FileInfoNode *pTempNode = pHead, *pTempNodeNext = NULL;
	while(pTempNode != NULL)
	{
		pTempNodeNext = pTempNode->pNext;
		delete pTempNode;
		pTempNode = pTempNodeNext;
	}
}

int getSleepFromRate(double dgSize, double reqBW)
{
     if(reqBW < 1)
          return 5000;
     double dgBits = dgSize*8.0;
     int sleep_us = (int)((dgBits + sqrt(dgBits*dgBits - 4*reqBW*BETA*dgBits)) / (2*reqBW));
     //sleep_us += 1;
     sleep_us = (sleep_us < 0)? 0 : sleep_us;
     
     return sleep_us;
}

int getRateFromSleep(double dgSize, double sleep_us)
{
     if(sleep_us <= 0) return -1;
     double dgBits = dgSize*8.0;
     return (int)((dgBits/sleep_us) - ((BETA*dgBits)/(sleep_us*sleep_us)));
}
		
/*int sendToWithLatency(int sockfd_udp, char *pDatagram, int length, struct sockaddr servaddr, int servlen)
{
     struct timeval timestamp;
     gettimeofday(&timestamp, NULL);
     datagramLatency[glb_index] = pDatagram;
     dgLengthLatency[glb_index] = length;
     timestampLatency[glb_index++] = timestamp;
     if(glb_index++ > MAX_LATENCY_SIZE)
          glb_index = 0;
     //a thread meanwhile checks the data structure and sends data
     //one it has been cooking for longer than the latency
}
int latency = 1000;
int MAX_LATENCY_SIZE = 5000000;
char **dataLatency;
int *dgLengthLatency;
struct timeval *timestampLatency;

void sendToLatencyThread(void *arg)
{
     dataLatency = new char*[MAX_LATENCY_SIZE];
     dgLengthLatency = new int[MAX_LATENCY_SIZE];
     timestampLatency = new struct timeval[MAX_LATENCY_SIZE];

     //get struct from arg which contains sockfd_udp, servaddr, servlen
     struct timeval timeNow;
     int index = 0;
     while(1)
     {
          struct timeval timestamp = timestampLatency[index];
          gettimeofday(&timeNow, NULL);
          if((timeNow.tv_usec-timestamp.tv_usec) + (timeNow.tv_sec-timestamp.tv_sec)* 1000000 > latency)
          {
               sendto(sockfd_udp, datagramLatency[index], dgLengthLatency[index], 0, (struct sockaddr *)&servaddr, servlen);
               index++;
               if(index > MAX_LATENCY_SIZE)
                    index = 0;
          }
     }
}*/

